﻿--[[                  
  TITAN PANEL: CAMERA DISTANCE
  Описание/Description:
• ru:  Дистанция Камеры - небольшой плагин для Титан Панели. Спомощью него можно установить максимальную дистанцию обзора камеры: от минимального - 0 метров (вид от первого лица) 
       до максимального - 50 метров и изменить некоторые опции камеры
• en:  Camera Distance - a small plug-in for Titan Panel. With him you can sets maximum range of camera distance: from minimum - 0 yards (first-person view) to maximum - 50 yards
       and change some Camera Options

 Author: Wishmaster (EU-Thermoplugg)    Автор: Вишмастер (RU-Термоштепсель)   
 E-mail: Wish1250@gmail.com             Мыло: Wish1250@gmail.com    
 Create Date: 9 june 2010               Дата создания: 9 июня 2010  
 Locales: RU,EN                         Языки: RU,EN

 Last Update: 23.11.2010                Последнее обновление: 23.11.2010 
 CurrentVersion: 2.0.1                  Текущая версия: 2.0.1
]]
local CAMDIST_VERSION = "2.0.1"
local CAMDIST_ID = "CamDist"
local updateTable = {CAMDIST_ID, TITAN_PANEL_UPDATE_ALL};
local L = LibStub("AceLocale-3.0"):GetLocale("TitanCamDist", true)
------------------------------------------------------------------------
function TitanPanelCamDistButton_OnLoad(self)
	self.registry = {
		id = CAMDIST_ID,
		category = "Interface",
        version = CAMDIST_VERSION,
		menuText = L["CAMDIST_MENUTEXT"],
		buttonTextFunction = "TitanPanelCamDist_GetButtonText",
        tooltipTitle = L["CAMDIST_TOOLTIPTITLE"],
        tooltipTextFunction = "TitanPanelCamDist_GetTooltipText",
		icon = "Interface\\Icons\\Ability_Hunter_MarkedForDeath",
		iconWidth = 16,
		savedVariables = {
		    ShowIcon = 1,
            ShowLabelText = 1,
            CameraAutoZoom = 1,
			}}; 
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end

--Автообновление
function TitanPanelCamDistButton_OnEvent(self, event, ...)
if event == "PLAYER_ENTERING_WORLD" then self:SetScript("OnUpdate", TitanPanelCamDistButton_OnUpdate) end
end 
function TitanPanelCamDistButton_OnUpdate(self) 
TitanPanelPluginHandle_OnUpdate(updateTable)
end
--Текст кнопки
function TitanPanelCamDist_GetButtonText()
return "|cffffffff"..L["CAMDIST_BUTTON_LABEL"],"|cff00ff00"..floor(GetCVar("cameraDistanceMax"))
end
--Текст подсказки
function TitanPanelCamDist_GetTooltipText() 
return L["CAMDIST_TOOLTIPTEXT"]
end
-- Автоизменение дистанции
local function CamDistAutoZoom()
TitanToggleVar(CAMDIST_ID, "CameraAutoZoom");
MoveViewOutStop()
TitanPanelPluginHandle_OnUpdate(updateTable)
end

------------------------------------------------------------------------
-- МЕНЮ
------------------------------------------------------------------------
function TitanPanelRightClickMenu_PrepareCamDistMenu()
local info;
------------------------------------------------------------------------
-- 3й УРОВЕНЬ
------------------------------------------------------------------------
        -- Меню 3 уровня, ОПЦИИ
        if ( UIDROPDOWNMENU_MENU_LEVEL == 3 ) then
        
        -- Опция "Скорость прокуртки" (1-45)
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOptMove" ) then
        for i=1,8 do
        info = {};
        info.notCheckable = true
		info.text = "x|cff00ff00"..(i*5).."|r    "
        info.func = function() 
        SetCVar("cameraDistanceMoveSpeed",i*5)
        DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_MOVE_TITLE"]..": |cff00ff00"..(i*5).."|r") end
		UIDropDownMenu_AddButton(info,3) end
        end
        
        -- Опция "Скорость поворота" (1-360)
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOptYaw" ) then
        for i=1,6 do
        info = {};
        info.notCheckable = true
        info.text = "|cff00ff00"..(i*60).."|r%    "
        info.func = function() 
        SetCVar("cameraYawMoveSpeed",i*60)
        DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_YAW_TITLE"]..": |cff00ff00"..(i*60).."|r") 
        end
        UIDropDownMenu_AddButton(info,3)
        end end
        
        -- Опция "Выравнивание" (0-никогда,2-всегда,4-только при движении,3-горизонт.,1-горизонт. при движении,5-горизонт. мгновенное)
        if  ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOptSmooth" ) then
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_SMOOTH_2"])
        info.func = function() SetCVar("cameraSmoothStyle",2) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_SMOOTH_TITLE"]..": "..L["CAMDIST_SMOOTH_2"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_SMOOTH_0"])
        info.func = function() 
        SetCVar("cameraSmoothStyle",0) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_SMOOTH_TITLE"]..": "..L["CAMDIST_SMOOTH_0"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_SMOOTH_4"])
        info.func = function() SetCVar("cameraSmoothStyle",4) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_SMOOTH_TITLE"]..": "..L["CAMDIST_SMOOTH_4"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_SMOOTH_3"])
        info.func = function() SetCVar("cameraSmoothStyle",3) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_SMOOTH_TITLE"]..": "..L["CAMDIST_SMOOTH_3"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_SMOOTH_1"])
        info.func = function() SetCVar("cameraSmoothStyle",1) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_SMOOTH_TITLE"]..": "..L["CAMDIST_SMOOTH_1"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_SMOOTH_5"])
        info.func = function() SetCVar("cameraSmoothStyle",5) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_SMOOTH_TITLE"]..": "..L["CAMDIST_SMOOTH_5"]) end;
		UIDropDownMenu_AddButton(info,3)
        end 
        
        -- Опция "Брызги воды" (вкл/выкл)
        if  ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOptWColl" ) then
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ffff"..L["CAMDIST_ON"])
        info.func = function() SetCVar("cameraWaterCollision",1) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_WCOLL"]..": "..L["CAMDIST_ON"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_OFF"])
        info.func = function() SetCVar("cameraWaterCollision",0) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_WCOLL"]..": "..L["CAMDIST_OFF"]) end;
		UIDropDownMenu_AddButton(info,3)
        end
        
        -- Опция "Следование рельефу" (вкл/выкл)
        if  ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOptTerTilt" ) then
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_ON"])
        info.func = function() SetCVar("cameraTerrainTilt",1) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_TERTILT"]..": "..L["CAMDIST_ON"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ffff"..L["CAMDIST_OFF"])
        info.func = function() SetCVar("cameraTerrainTilt",0) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_BOBBING"]..": "..L["CAMDIST_OFF"]) end;
		UIDropDownMenu_AddButton(info,3)
        end
        
        -- Опция "Покачивание головы" (вкл/выкл)
        if  ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOptBobbing" ) then
        info = {};
        info.notCheckable = true
		info.text = (L["CAMDIST_ON"])
        info.func = function() SetCVar("cameraBobbing",1) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_BOBBING"]..": "..L["CAMDIST_ON"]) end;
		UIDropDownMenu_AddButton(info,3)
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ffff"..L["CAMDIST_OFF"])
        info.func = function() SetCVar("cameraBobbing",0) DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_BOBBING"]..": "..L["CAMDIST_OFF"]) end;
		UIDropDownMenu_AddButton(info,3)
        end
         
        -- Опция "Сброс в стандарт"
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOptReset" ) then
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_RES_ACP"]
        info.func = function() 
        SetCVar("cameraYawMoveSpeed",200) 
        SetCVar("cameraSmoothStyle",4) 
        SetCVar("cameraDistanceMoveSpeed",10) 
        SetCVar("cameraBobbing",0) 
        SetCVar("cameraTerrainTilt",0) 
        SetCVar("cameraWaterCollision",1) 
        SetCVar("cameraDistanceMax",15) 
        MoveViewOutStart(1)
        DEFAULT_CHAT_FRAME:AddMessage(L["CAMDIST_TITAN"]..L["CAMDIST_RESET_MSG"]) 
        TitanPanelPluginHandle_OnUpdate(updateTable)
        TitanPanelRightClickMenu_Close(1) 
        end;
		UIDropDownMenu_AddButton(info,3)
        end
        
------------------------------------------------------------------------
-- 2й УРОВЕНЬ
------------------------------------------------------------------------ 
        -- Меню 2го уровня,ДИСТАНЦИИ
        elseif ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then   
        -- Меню 2го уровня, Дистанции 1-9 
		if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist0" ) then
        for i=1,9 do
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ff00"..i.."|r"..L["CAMDIST_METER"].."")
        info.func = function() 
        SetCVar("cameraDistanceMaxFactor",1)
        SetCVar("cameraDistanceMax",i)
        if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end
        end;
		UIDropDownMenu_AddButton(info,2)
        end
        end

        -- Меню 2го уровня, Дистанции 11-19  
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist10" ) then
        for i=11,19 do
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ff00"..i.."|r"..L["CAMDIST_METER"].."")
        info.func = function() 
        SetCVar("cameraDistanceMaxFactor",1)
        SetCVar("cameraDistanceMax",i)
        if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1) end
        end;
		UIDropDownMenu_AddButton(info,2)
        end
        end
   
        -- Меню 2го уровня, Дистанции 21-29          
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist20" ) then
		for i=21,29 do
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ff00"..i.."|r"..L["CAMDIST_METER"].."")
        info.func = function() 
        SetCVar("cameraDistanceMaxFactor",1)
        SetCVar("cameraDistanceMax",i)
        if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
        end;
		UIDropDownMenu_AddButton(info,2)
        end
        end
        
        -- Меню 2го уровня, Дистанции 31-39         
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist30" ) then
        for i=31,39 do
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ff00"..i.."|r"..L["CAMDIST_METER"].."")
        info.func = function() 
        SetCVar("cameraDistanceMaxFactor",1)
        SetCVar("cameraDistanceMax",i)
        if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
        end;
		UIDropDownMenu_AddButton(info,2)
        end
        end
        
        -- Меню 2го уровня, Дистанции 41-49         
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist40" ) then
        for i=41,49 do
        info = {};
        info.notCheckable = true
		info.text = ("|cff00ff00"..i.."|r"..L["CAMDIST_METER"].."")
        info.func = function() 
        SetCVar("cameraDistanceMaxFactor",1)
        SetCVar("cameraDistanceMax",i)
        if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
        end;
		UIDropDownMenu_AddButton(info,2)
        end
        end 
          
        -- Меню 2го уровня, ОПЦИИ КАМЕРЫ
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDistOpt" ) then
        -- Меню 2го уровня, "Выравнивание камеры"
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_OPT_SMOOTH"]
        info.value = "CamDistOptSmooth"
        info.hasArrow = 1;
		UIDropDownMenu_AddButton(info,2)
        -- Меню 2го уровня, "Скорость прокуртки камеры" 
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_MOVE_TITLE"]
        info.value = "CamDistOptMove"
        info.hasArrow = 1;
		UIDropDownMenu_AddButton(info,2) 
        -- Меню 2го уровня, "Скорость поворота камеры"
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_YAW_TITLE"]
        info.value = "CamDistOptYaw"
        info.hasArrow = 1;
		UIDropDownMenu_AddButton(info,2) 
        -- Меню 2го уровня, "Брызги воды"
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_WCOLL"]
        info.value = "CamDistOptWColl"
        info.hasArrow = 1;
		UIDropDownMenu_AddButton(info,2) 
        -- Меню 2го уровня, Покачивание
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_BOBBING"] 
        info.value = "CamDistOptBobbing"
        info.hasArrow = 1;
		UIDropDownMenu_AddButton(info,2) 
        -- Меню 2го уровня, Следование рельефу
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_TERTILT"]
        info.value = "CamDistOptTerTilt"
        info.hasArrow = 1;
		UIDropDownMenu_AddButton(info,2) 
        -- Меню 2го уровня, пустая строка
        TitanPanelRightClickMenu_AddSpacer(2)
        -- Меню 2го уровня, Сброс в стандарт
        info = {};
        info.notCheckable = true
		info.text = L["CAMDIST_RESET"]
        info.value = "CamDistOptReset"
        info.hasArrow = 1;
		UIDropDownMenu_AddButton(info,2)
        end 
        else       
------------------------------------------------------------------------
-- 1й УРОВЕНЬ
------------------------------------------------------------------------
    -- Дистанции 0,10,20,30,40,50.   
   	TitanPanelRightClickMenu_AddTitle(L["CAMDIST_MENU"])
   	info = {};
    info.notCheckable = true
   	info.text = ("   |cff00ff000|r"..L["CAMDIST_METER"].."")
    info.value = "CamDist0"
    info.func = function()
    SetCVar("cameraDistanceMax",0)
    SetCVar("cameraDistanceMaxFactor",1)
    if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1) end end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);
    
    info = {};
    info.notCheckable = true
   	info.text = ("|cff00ff0010|r"..L["CAMDIST_METER"].."")
    info.value = "CamDist10"
    info.func = function()
    SetCVar("cameraDistanceMax",10)
    SetCVar("cameraDistanceMaxFactor",1)
    if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);
    
   	info = {};
    info.notCheckable = true
   	info.text = ("|cff00ff0020|r"..L["CAMDIST_METER"].."")
    info.value = "CamDist20"
    info.func = function()
    SetCVar("cameraDistanceMax",20)
    SetCVar("cameraDistanceMaxFactor",1)
    if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);

   	info = {};
    info.notCheckable = true
   	info.text = ("|cff00ff0030|r"..L["CAMDIST_METER"].."")
    info.hasArrow = 1;
    info.value = "CamDist30"
    info.func = function()
    SetCVar("cameraDistanceMax",30)
    SetCVar("cameraDistanceMaxFactor",1)
    if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end end;
    UIDropDownMenu_AddButton(info);

   	info = {};
    info.notCheckable = true
   	info.text = ("|cff00ff0040|r"..L["CAMDIST_METER"].."")
    info.value = "CamDist40"
    info.func = function()
    SetCVar("cameraDistanceMax",40)
    SetCVar("cameraDistanceMaxFactor",1)
    if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end end;
    info.hasArrow = 1
    UIDropDownMenu_AddButton(info);
    
    info = {};
    info.notCheckable = true
   	info.text = ("|cff00ff0050|r"..L["CAMDIST_METER"].."")
    info.value = "CamDist50"
    info.func = function() 
    SetCVar("cameraDistanceMax",50)
    SetCVar("cameraDistanceMaxFactor",1)
    if (TitanGetVar(CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(3) end end;
    UIDropDownMenu_AddButton(info);
    
    TitanPanelRightClickMenu_AddSpacer()
    
    -- Дополнительные опции
    info = {};
    info.notCheckable = true
   	info.text = L["CAMDIST_OPTIONS"]
    info.value = "CamDistOpt"
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);
    info = {};
	info.text = L["CAMDIST_AUTOZOOM"];
    info.func = function() CamDistAutoZoom() end;
    info.checked = TitanGetVar(CAMDIST_ID, "CameraAutoZoom");
    UIDropDownMenu_AddButton(info)
    
	TitanPanelRightClickMenu_AddToggleIcon(CAMDIST_ID); 
    TitanPanelRightClickMenu_AddToggleLabelText(CAMDIST_ID);
end
end

-- Ну надо же было добавить сюда чего-нибудь интересного, вот и придумал это)):
SLASH_TITANCAMDIST1 = "/CamDist"
SlashCmdList["TITANCAMDIST"] = TITANCAMDIST_Command
local sfuncoff, sfuncon
if GetLocale() == "ruRU" then sfuncoff = "Секретная функция |cffff0000Отключена|r. Спасибо за использование этого Аддона. /Вишмастер" else sfuncoff = "Secret function |cffff0000OFF|r. Thanks for using this Addon. /Wishmaster" end
if GetLocale() == "ruRU" then sfuncon  = "Незнаю как, но Вы |cff00ff00Включили|r Секретную функцию. =) Чтобы отключить ее напишите '|cff00ff00/camdist off|r'." else sfuncon = "It's not known how, but you have turn |cff00ff00ON|r a Secret function. =) To turn off it write '|cff00ff00/camdist off|r'." end
function TITANCAMDIST_Command(msg)
if msg == "off" then
-- отключение
DEFAULT_CHAT_FRAME:AddMessage(sfuncoff)
SetCVar("cameraDistanceMax",25)
MoveViewLeftStop()
MoveViewOutStop()
SetView(4)
else
-- включение
DEFAULT_CHAT_FRAME:AddMessage(sfuncon)
SetView(1)
SetCVar("cameraDistanceMax",50)
MoveViewLeftStart(0.1)
MoveViewOutStart(0.1)
end
end 

--[[ P.S.: С этим аддоном мне помогли:
 • Заки - самый большой склерозник:  разборки с yard-yards
 • Мизи и ЗлойКот(ака Русский во всех его формах и проявлениях): дефолтные настройки клиента 
]]--